<template>
  <q-dialog v-model="showDialog" @hide="closeDialog" persistent>
    <q-card style="width: 900px; max-width: 80vw">
      <q-bar>
        Correccion de rama
        <q-space />
        <q-btn dense flat icon="close" v-close-popup @click="CancelarDialog">
          <q-tooltip>Close</q-tooltip>
        </q-btn>
      </q-bar>
      <q-card-section class="q-pa-none">
        <q-list dense bordered padding class="rounded-borders">
          <q-item>
            <q-item-section>
              <PersonaDetalle :persona="participante.persona" />
            </q-item-section>
            <q-item-section>
              <SelectRama :multiple="false" v-model="rama" />
            </q-item-section>
          </q-item>
        </q-list>
      </q-card-section>
      <q-card-actions align="right">
        <q-btn
          flat
          label="Cambiar Rama"
          color="primary"
          v-close-popup
          @click="cambiarRama"
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script lang="ts">
import { PropType, defineComponent, ref, onMounted } from 'vue';
import { api } from 'src/boot/axios/index';
import { useQuasar } from 'quasar';
import PersonaDetalle from 'components/Personas/Detalle.vue';
import SelectRama from 'components/Form/selectRama.vue';
import { EventosInscriptosInterface } from 'src/interfaces/EventosInterface';

export default defineComponent({
  name: 'DialogCorregirRamaPartial',
  props: {
    show: Boolean,
    participante: {
      type: Object as PropType<EventosInscriptosInterface>,
      required: true,
    },
  },
  emits: ['update:show', 'close'],

  components: {
    PersonaDetalle,
    SelectRama,
  },

  setup(props, { emit }) {
    const $q = useQuasar();
    const showDialog = ref(props.show);
    const rama = ref('C');

    onMounted(() => {
      rama.value = props.participante.rama;
    });

    function cambiarRama() {
      api
        .post('/api/eventos/inscriptos/rama', {
          uuid: props.participante.uuid,
          rama: rama.value,
        })
        .then(() => {
          closeDialog();
        });
    }

    function CancelarDialog() {
      $q.notify({
        message: 'Edicion de rama Cancelada',
        color: 'red',
        position: 'top',
      });
      closeDialog();
    }

    function closeDialog() {
      showDialog.value = false;
      emit('update:show', false);
      emit('close');
    }

    return {
      rama,
      cambiarRama,
      showDialog,
      closeDialog,
      CancelarDialog,
    };
  },
});
</script>
